//Iorga Cosmin 332 cA


#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>

#define DURATION 200

#define MULTI_TONE 0


// E2 - > E5
float note[100]={
	82.41,87.31,92.5,98,103.83,110,116.54,123.47,130.81,138.59,146.83,155.56,
	164.81,174.61,185,196,207.65,220,233,246.94,261.63,277.18,293.66,311.13,
	329.63,349.23,370,392,415.3,440,466.16,493.88,523.25,554.37,587.33,622.25	
};

unsigned int adc_read() 
{
    ADCSRA |= _BV(ADSC);
	loop_until_bit_is_set(ADCSRA,ADIF); 
	return ADC;
}

void init_adc() 
{
	ADCSRA |= ((1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0));		
	
	ADMUX |= (1<<REFS0);                				
	
	ADCSRA |= (1<<ADEN);                				
	ADCSRA |= (1<<ADSC);                 
}

void init_buttons()
{
	DDRD |= (1 << PD6);
	PORTD &= ~(1 << PD6);
	
	DDRD &= ~((1<<PD0) | (1<<PD1) | (1<<PD2) | (1<<PD3) | (1<<PD4));
	PORTD |= ((1<<PD0) | (1<<PD1) | (1<<PD2) | (1<<PD3) | (1<<PD4));
	
	DDRC &= ~((1<<PC1) | (1<<PC2) | (1<<PC3) | (1<<PC4) | (1<<PC5) | (1<<PC6) | (1<<PC7));
	PORTC |= ((1<<PC1) | (1<<PC2) | (1<<PC3) | (1<<PC4) | (1<<PC5) | (1<<PC6) | (1<<PC7));
}

void playnote(float duration, float frequency)
{
	long int i,cycles;
	float half_period;	
	float wavelength;
	 
	wavelength=(1/frequency)*1000;	
	cycles=duration/wavelength;	    
	half_period = wavelength/2;		

	DDRD |= (1 << PD6);

	for (i=0;i<cycles;i++) 			
	{
		_delay_ms(half_period);							
		PORTD |= (1 << PD6);					
		_delay_ms(half_period);						
		PORTD &= ~(1 << PD6);				
	}

	return;		
}

void silence ()
{
	PORTD &= ~(1 << PD6);
}

void decide (int index, int note_index,int duration)
{
	int value = adc_read(index);
	
	if(MULTI_TONE)
	{
		if (value < 400)
				playnote(duration,note[note_index+1]);
			else
		if (value < 800)
				playnote(duration,note[note_index]);
			else
		silence();
	}
	else
	{
		if (value < 40)
			playnote(duration,note[note_index]);
		else
			silence();
	}

}


int button_offset()
{

	if( (PIND & (1 << PD0)) == 0 )
	{
	    return 1 * (MULTI_TONE + 1);
	}
	
	if( (PIND & (1 << PD1)) == 0 )
	{
	    return 2 * (MULTI_TONE + 1);
	}
	
	if( (PINC & (1 << PC1)) == 0 )
	{
	    return 3 * (MULTI_TONE + 1);
	}
	
	if( (PIND & (1 << PD3)) == 0 )
	{
	    return 4 * (MULTI_TONE + 1);
	}
	
	if( (PIND & (1 << PD4)) == 0)
	{
	    return 5 * (MULTI_TONE + 1);
	}
	
	
	return 0;
}

void reset_admux()
{
	ADMUX &= ~(1<<MUX0);
	ADMUX &= ~(1<<MUX1);
	ADMUX &= ~(1<<MUX2);
}

void sing() 
{
	init_adc();
	init_buttons();

	int val_button = 0 ;
	
	while(1) 
	{	
		val_button = button_offset();
		
		//ADC 7		
		ADMUX |= (1<<MUX2) | (1<<MUX1) | (1<<MUX0);		
		decide(7, 0  + val_button,DURATION);
		reset_admux();
		
		// ADC6
		ADMUX |= (1<<MUX2) | (1<<MUX1);
		decide(6, 5  + val_button,DURATION);
		reset_admux();
		
		// ADC5
		ADMUX |= (1<<MUX2) | (1<<MUX0);
		decide(5, 10 + val_button,DURATION);
		reset_admux();
		
		// ADC4
		ADMUX |= (1<<MUX2);
		decide(4, 15 + val_button,DURATION);
		reset_admux();
		
		// ADC3
		ADMUX |= (1<<MUX1) | (1<<MUX0);
		decide(3, 19 + val_button,DURATION);
		reset_admux();
		
		// ADC2
		ADMUX |= (1<<MUX1);
		decide(2, 23 + val_button,DURATION);
		reset_admux();
	}	
	
}


int main(void) 
{
	sing();

	return 0;
}

